# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Empire**, the allocation and nomination platform of BritNed_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/britned/empire-platform-api) 

    The version of the OpenAPI document: 6.0.3
    Contact: britned.info@britned.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr
from empire_platform_api_public_client_legacy.models.auction_product_type import AuctionProductType
from empire_platform_api_public_client_legacy.models.border_direction import BorderDirection
from empire_platform_api_public_client_legacy.models.date_time_period import DateTimePeriod
from empire_platform_api_public_client_legacy.models.mtu_period import MtuPeriod

class BuyNowOfferOverviewItem(BaseModel):
    """
    BuyNowOfferOverviewItem
    """
    display_id: StrictStr = Field(default=..., alias="displayId")
    validity_period: DateTimePeriod = Field(default=..., alias="validityPeriod")
    delivery_period: MtuPeriod = Field(default=..., alias="deliveryPeriod")
    product_type: AuctionProductType = Field(default=..., alias="productType")
    direction: BorderDirection = Field(...)
    __properties = ["displayId", "validityPeriod", "deliveryPeriod", "productType", "direction"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BuyNowOfferOverviewItem:
        """Create an instance of BuyNowOfferOverviewItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of validity_period
        if self.validity_period:
            _dict['validityPeriod'] = self.validity_period.to_dict()
        # override the default output from pydantic by calling `to_dict()` of delivery_period
        if self.delivery_period:
            _dict['deliveryPeriod'] = self.delivery_period.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BuyNowOfferOverviewItem:
        """Create an instance of BuyNowOfferOverviewItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BuyNowOfferOverviewItem.parse_obj(obj)

        _obj = BuyNowOfferOverviewItem.parse_obj({
            "display_id": obj.get("displayId"),
            "validity_period": DateTimePeriod.from_dict(obj.get("validityPeriod")) if obj.get("validityPeriod") is not None else None,
            "delivery_period": MtuPeriod.from_dict(obj.get("deliveryPeriod")) if obj.get("deliveryPeriod") is not None else None,
            "product_type": obj.get("productType"),
            "direction": obj.get("direction")
        })
        return _obj


